#include "RS232_2.h"


//---------------------------------------------------------------------------------------
// Function: Read_Single_Char
//	Reads a single char from the RS232 Buffer
// Parameters:
//	hPort: Port to be read
//	pData: Read data to be saved in pData
// Return Value:
//	Result: indicates the result of read opertion
//---------------------------------------------------------------------------------------
HRESULT Read_Single_Char( HANDLE hPort, PBYTE pData )
{
    HRESULT Result = S_OK ;
    DWORD   dwBytesRead ;

    if( !ReadFile( hPort, pData, 1, &dwBytesRead, NULL ) )
    {
        Result = GetLastError( ) ;
		printf("Read");
        goto End ;
    }

    if( !dwBytesRead )
    {   // Read operation timed out.
        Result = WAIT_TIMEOUT ;
		printf("TimeOut");
    }

End :
    return Result ;
}

//---------------------------------------------------------------------------------------
// Function: Write_Single_Char
//	Writes a single char from the RS232 Buffer
// Parameters:
//  hPort		: Port to be write
//	pData		: Data to be write in pData
//	dwBytesWrite: Bytes to write
// Return Value:
//	Result: indicates the result of read opertion
//---------------------------------------------------------------------------------------
void Write_Single_Char( HANDLE hPort, PBYTE pData,DWORD dwBytesWrite )
{
    HRESULT Result = S_OK ;
    if( !WriteFile( hPort, pData, 1, &dwBytesWrite, NULL ) )
    {
        Result = GetLastError( ) ;
    }

    if( !dwBytesWrite )
    {   // Read operation timed out.
        Result = WAIT_TIMEOUT ;
		//cout<<"Fehler\n";
    }

}

