using System;
using System.IO;
using System.Threading;

using EvalBoard;

//namespace SerialStreamReader 
//{

	class RS232Handler
	{
		static Thread tListener=null;

		#region Private_Variables
		
		static SerialStream ss;
		
		static byte [] sof=new byte[1];
		
		static byte [] time=new byte[6];
		static ulong actual_time;
		
		static byte [] msgType=new byte[1];
		static uint mType;
		
		static byte [] canType=new byte[1];
		static uint cType;
		
		static byte [] id_s=new byte[4];
		static byte [] id_e=new byte[8];
		static ulong id_global;

		static byte [] dlc=new byte[1];
		static uint rxDLC;
		
		static byte [] data;
		static uint [] rxData;
		
		static byte [] crc=new byte[2];
		static uint [] txCRC=new uint[2];
		
		static byte [] eof=new byte[1];
		
		static byte [] ack=new byte[1];
		static byte [] error=new byte[2];

		#endregion Private_Variables
		
		#region RS232_IFunktions

		public static bool PortConfig()
		{
			ss = new SerialStream();

			try 
			{
				ss.Open("COM1");
			}
			catch (Exception e) 
			{
				Console.WriteLine("Error: " + e.Message);
				Console.ReadLine();
				return false;
			}

			// Set Port settings

			ss.SetPortSettings(19200,SerialStream.FlowControl.None,SerialStream.Parity.None,8,SerialStream.StopBits.One);

			ss.SetTimeouts(0,0,0,0,0);
			return true;
		}

		
		public static void Listen()
		{
			ack[0]=0x06;
			while(true)
			{
				ss.BeginRead(sof,0,0,null,null);
				ss.EndRead(ss.BeginRead(sof));
			}//ende while
		}//ende Listen Funktion

		public static Thread GetListener()
		{
			
			if(tListener==null)
			{
				tListener=new Thread(new ThreadStart(Listen));
				return tListener;
			}
			else
			{
				return null;
			}
			

		}
		public static void StartStopListenThread(int id,bool sbit)
		{
			Thread t1=GetListener();

			if(t1==null&&sbit==false)
			{
				tListener.Suspend();
			}

			if(t1!=null&&sbit==true)
			{
				t1.Start();
			}
		}

		#endregion RS232_IFunktions

		
		

		[STAThread]
		static void Main(string[] args) 
		{
			String s;
			byte [] buffer=new  byte[256];
			byte [] statusFrame={0x17,0x35,0x35,0x03};
			byte [] initFrame_CAN1={0x14,0x31,0x35,0x37,0x2D,0x30,0x41,0x03};
			byte [] initFrame_CAN2={0x14,0x32,0x35,0x37,0x2D,0x30,0x39,0x03};
			byte [] data={0x02,0x2D,0x31,0x31,0x32,0x33,0x36,0x31,0x32,0x35,0x32,0x46,0x36,0x38,0x39,0x41,0x43,0x31,0x44,0x03};
			
			// Create a serial port
			ss = new SerialStream();
			
			PortConfig();
			StartStopListenThread(1,true);
			Console.ReadLine();
			StartStopListenThread(1,false);			
			s=Console.ReadLine();
			if(s.Equals("exit")||s.Equals("Exit")||s.Equals("EXIT"))
			{
				ss.Close();
			}
		}	
	}
//}
